/*
** ###################################################################
**     This code is generated by the Device Initialization Tool.
**     It is overwritten during code generation.
**     USER MODIFICATION ARE PRESERVED ONLY INSIDE INTERRUPT SERVICE ROUTINES
**
**     Project   : DC15
**     Processor : MC9S08QG8CPB
**     Version   : Bean 01.250, Driver 01.03, CPU db: 2.87.115
**     Datasheet : MC9S08QG8 Rev. 2 6/2006
**     Date/Time : 9/13/2007, 6:30 PM
**     Abstract  :
**         This module contains device initialization code 
**         for selected on-chip peripherals.
**     Contents  :
**         Function "MCU_init" initializes selected peripherals
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################
*/

#include <MC9S08QG8.h>                 /* I/O map for MC9S08QG8CPB */


/*
** ===================================================================
**     Method      :  MCU_init (bean MC9S08QG8_16)
**
**     Description :
**         Device initialization code for selected peripherals.
** ===================================================================
*/
void MCU_init(void)
{
  /* ### MC9S08QG8_16 "Cpu" init code ... */
  /*  PE initialization code after reset */
  /* Common initialization of the write once registers */
  /* SOPT1: COPE=0,COPT=1,STOPE=1,BKGDPE=1,RSTPE=0 */
  SOPT1 = 0x72;                                      
  /* SPMSC1: LVDF=0,LVDACK=0,LVDIE=0,LVDRE=1,LVDSE=1,LVDE=1,BGBE=0 */
  SPMSC1 = 0x1C;                                      
  /* SPMSC2: PDF=0,PPDF=0,PPDACK=0,PDC=0,PPDC=0 */
  SPMSC2 = 0x00;                                      
  /* SPMSC3: LVDV=0,LVWV=0 */
  SPMSC3 &= (unsigned char)~0x30;                     
  /*  System clock initialization */
  ICSTRM = *(unsigned char*far)0xFFAF; /* Initialize ICSTRM register from a non volatile memory */
  ICSSC = *(unsigned char*far)0xFFAE;  /* Initialize ICSSC register from a non volatile memory */
  /* ICSC1: CLKS=0,RDIV=0,IREFS=1,IRCLKEN=0,IREFSTEN=0 */
  ICSC1 = 0x04;                        /* Initialization of the ICS control register 1 */
  /* ICSC2: BDIV=0,RANGE=0,HGO=0,LP=0,EREFS=0,ERCLKEN=0,EREFSTEN=0 */
  ICSC2 = 0x00;                        /* Initialization of the ICS control register 2 */
  /* Common initialization of the CPU registers */
  /* PTASE: PTASE4=1,PTASE3=1,PTASE2=1,PTASE1=1,PTASE0=1 */
  PTASE |= (unsigned char)0x1F;                               
  /* PTBSE: PTBSE7=1,PTBSE6=1,PTBSE5=1,PTBSE4=1,PTBSE3=1,PTBSE2=1,PTBSE1=1,PTBSE0=1 */
  PTBSE = 0xFF;                                      
  /* PTADS: PTADS5=0,PTADS4=0,PTADS3=0,PTADS2=0,PTADS1=0,PTADS0=0 */
  PTADS = 0x00;                                      
  /* PTBDS: PTBDS7=0,PTBDS6=0,PTBDS5=0,PTBDS4=0,PTBDS3=0,PTBDS2=0,PTBDS1=0,PTBDS0=0 */
  PTBDS = 0x00;                                      
  /* ### Init_FLASH init code */
  /* FCDIV: DIVLD=0,PRDIV8=0,DIV5=1,DIV4=1,DIV3=0,DIV2=0,DIV1=0,DIV0=1 */
  FCDIV = 0x31;                        /* Set clock divider */
  /* ### Init_GPIO init code */
  /* PTBD: PTBD7=0,PTBD6=0,PTBD5=0,PTBD4=0 */
  PTBD &= (unsigned char)~0xF0;                     
  /* PTBPE: PTBPE7=0,PTBPE6=0,PTBPE5=0,PTBPE4=0 */
  PTBPE &= (unsigned char)~0xF0;                     
  /* PTBDD: PTBDD7=1,PTBDD6=1,PTBDD5=1,PTBDD4=1 */
  PTBDD |= (unsigned char)0xF0;                               
  /* ### Init_RTI init code */
  /* SRTISC: RTIF=0,RTIACK=1,RTICLKS=0,RTIE=1,RTIS2=0,RTIS1=0,RTIS0=1 */
  SRTISC = 0x51;                                      
  /* ### Init_ADC init code */
  /* APCTL1: ADPC7=0,ADPC6=0,ADPC5=0,ADPC4=0,ADPC3=0,ADPC2=1,ADPC1=1,ADPC0=1 */
  APCTL1 = 0x07;                                      
  /* ADCCFG: ADLPC=0,ADIV1=0,ADIV0=0,ADLSMP=0,MODE1=0,MODE0=0,ADICLK1=0,ADICLK0=0 */
  ADCCFG = 0x00;                                      
  /* ADCSC2: ADACT=0,ADTRG=0,ACFE=0,ACFGT=0 */
  ADCSC2 = 0x00;                                      
  /* ADCCV: ADCV9=0,ADCV8=0,ADCV7=0,ADCV6=0,ADCV5=0,ADCV4=0,ADCV3=0,ADCV2=0,ADCV1=0,ADCV0=0 */
  ADCCV = 0x00;                                      
  /* ADCSC1: COCO=0,AIEN=0,ADCO=0,ADCH4=0,ADCH3=0,ADCH2=0,ADCH1=1,ADCH0=0 */
  ADCSC1 = 0x02;                                      
  /* ### */
  asm CLI;                             /* Enable interrupts */
} /*MCU_init*/


/*
** ===================================================================
**     Interrupt handler : isrVrti
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVrti(void)
{
  /* Write your interrupt code here ... */
  RTI_ISR();
}
/* end of isrVrti */


/*
** ===================================================================
**     Interrupt handler : isrVadc
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVadc(void)
{
  /* Write your interrupt code here ... */

}
/* end of isrVadc */



/* Initialization of the CPU registers in FLASH */

/* NVPROT: FPS=0x7F,FPDIS=1 */
const unsigned char NVPROT_INIT @0x0000FFBD = 0xFF;

/* NVOPT: KEYEN=0,FNORED=1,SEC01=1,SEC00=0 */
const unsigned char NVOPT_INIT @0x0000FFBF = 0x7E;



extern near void _Startup(void);

/* Interrupt vector table */
#define UNASSIGNED_ISR 0xFFFF          /* unassigned interrupt service routine */

void (* near const _vect[])() @0xFFD0 = { /* Interrupt vector table */
         isrVrti,                      /* Int.no. 23 Vrti (at FFD0)                  Used */
         UNASSIGNED_ISR,               /* Int.no. 22 Reserved2 (at FFD2)             Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 21 Reserved3 (at FFD4)             Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 20 Vacmp (at FFD6)                 Unassigned */
         isrVadc,                      /* Int.no. 19 Vadc (at FFD8)                  Used */
         UNASSIGNED_ISR,               /* Int.no. 18 Vkeyboard (at FFDA)             Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 17 Viic (at FFDC)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 16 Vscitx (at FFDE)                Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 15 Vscirx (at FFE0)                Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 14 Vscierr (at FFE2)               Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 13 Vspi (at FFE4)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 12 Vmtim (at FFE6)                 Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 11 Reserved13 (at FFE8)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 10 Reserved14 (at FFEA)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  9 Reserved15 (at FFEC)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  8 Reserved16 (at FFEE)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  7 Vtpmovf (at FFF0)               Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  6 Vtpmch1 (at FFF2)               Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  5 Vtpmch0 (at FFF4)               Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  4 Reserved20 (at FFF6)            Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  3 Vlvd (at FFF8)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  2 Virq (at FFFA)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  1 Vswi (at FFFC)                  Unassigned */
         _Startup                      /* Int.no.  0 Vreset (at FFFE)                Reset vector */
 };




/* END */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 3.00 [03.89]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
